#pragma once
#include <SFML/Graphics.hpp>

namespace config {
    // Общее:
    constexpr unsigned int FRAME_RATE_LIMIT = 60;
    // Меню:
    const sf::Vector2f BUTTON_SIZE = { 250, 80 };
    const size_t BUTTON_FONT_SIZE = static_cast<size_t>(BUTTON_SIZE.y / 1.5f);
    constexpr float BUTTON_FRAME_THICKNESS = 2.0f;
    constexpr char FONT_FILE[] = ASSETS_PATH "calibril.ttf";
    constexpr char SELECT_LEVEL_TITLE[] = "Select Level";
    const sf::VideoMode SELECT_LEVEL_VIDEO_MODE{ 400, 600 };
    constexpr char BUTTON_TEXT_EASY[] = "Easy";
    constexpr char BUTTON_TEXT_MEDIUM[] = "Medium";
    constexpr char BUTTON_TEXT_HARD[] = "Hard";
    constexpr char BUTTON_TEXT_EXTREME[] = "Extreme";
    constexpr char BUTTON_TEXT_EXIT[] = "Exit";
    // Игра:
    const sf::VideoMode GAME_VIDEO_MODE{ 1080, 720 };
    constexpr char EASY_GAME_TITLE[] = "Level: Easy";
    constexpr char MEDIUM_GAME_TITLE[] = "Level: Medium";
    constexpr char HARD_GAME_TITLE[] = "Level: Hard";
    constexpr char EXTREME_GAME_TITLE[] = "Level: Extreme";
    constexpr float EASY_GAME_ENEMY_RATIO = 0.0f;
    constexpr float MEDIUM_GAME_ENEMY_RATIO = 0.03f;
    constexpr float HARD_GAME_ENEMY_RATIO = 0.07f;
    constexpr float ROOM_SIZE = 50;
    constexpr float GAME_ENEMY_SIZE = ROOM_SIZE * 0.7;
    constexpr float GAME_FOOD_SIZE = ROOM_SIZE * 0.1;
    constexpr float ENEMY_SPEED = 80;
    constexpr float PACMAN_SPEED = 300;
    // Пакмэн:
    constexpr float GAME_PACMAN_SIZE = ROOM_SIZE * 0.8;
    constexpr sf::Keyboard::Key KEY_LEFT = sf::Keyboard::A;
    constexpr sf::Keyboard::Key KEY_RIGHT = sf::Keyboard::D;
    constexpr sf::Keyboard::Key KEY_UP = sf::Keyboard::W;
    constexpr sf::Keyboard::Key KEY_DOWN = sf::Keyboard::S;
    constexpr sf::Keyboard::Key KEY_LEFT_2 = sf::Keyboard::Left;
    constexpr sf::Keyboard::Key KEY_RIGHT_2 = sf::Keyboard::Right;
    constexpr sf::Keyboard::Key KEY_UP_2 = sf::Keyboard::Up;
    constexpr sf::Keyboard::Key KEY_DOWN_2 = sf::Keyboard::Down;
    // Цвета:
    const sf::Color BUTTON_COLOR_TEXT{ 0, 0, 0 };
    const sf::Color BUTTON_COLOR_FILL{ 180, 180, 180 };
    const sf::Color BUTTON_COLOR_SELECTION{ 255, 180, 180 };
    const sf::Color BUTTON_COLOR_FRAME{ 0, 0, 0 };
    const sf::Color SELECT_LEVEL_BACKGROUND_COLOR{ 230,230,230 };
    const sf::Color GAME_COLOR_PACMAN{ 250, 150, 0 };
    const sf::Color GAME_COLOR_ROOM{ 255, 255, 255 };
    const sf::Color GAME_COLOR_WALL{ 0, 0, 0 };
    const sf::Color GAME_FOOD_COLOR{ 0, 200, 100 };
    const sf::Color GAME_ENEMY_COLOR{ 255, 50, 0 };
    // Состояния игры:
    const sf::Color GAME_COLOR_BACKGROUND_INGAME{ 230,230,230 };
    const sf::Vector2f NOTIFICATION_BANNER_SIZE = {
        static_cast<float>(GAME_VIDEO_MODE.width)/1.5f, static_cast<float>(GAME_VIDEO_MODE.height)/3.0f };
    const size_t NOTIFICATION_FONT_SIZE = static_cast<size_t>(NOTIFICATION_BANNER_SIZE.y / 2.f);
    const sf::Color TEXT_COLOR_NOTIFICATION{ 0, 0, 0, 255};
    const sf::Color NOTIFICATION_BANNER_COLOR_PLAY{ 0, 100, 255, 200 };
    constexpr char TEXT_PLAY[] = "PRESS SPACE";
    const sf::Color GAME_COLOR_BACKGROUND_PAUSE{ 255, 255, 128 };
    const sf::Color NOTIFICATION_BANNER_COLOR_PAUSE{ 255, 255, 128, 200 };
    constexpr char TEXT_PAUSE[] = "PAUSE";
    const sf::Color GAME_COLOR_BACKGROUND_LOST{ 255, 0, 0 };
    const sf::Color NOTIFICATION_BANNER_COLOR_LOST{ 255, 0, 0, 180 };
    constexpr char TEXT_LOST[] = "DEFEAT!";
    const sf::Color GAME_COLOR_BACKGROUND_WIN{ 0, 255, 0 };
    const sf::Color NOTIFICATION_BANNER_COLOR_WIN{ 0, 240, 0, 200 };
    constexpr char TEXT_WIN[] = "WIN!";
}
